import { w as withInstall } from "../badge/index2.js";
import { defineComponent, useSlots, openBlock, createElementBlock, createElementVNode, normalizeClass, toDisplayString, renderSlot } from "vue";
var index = /* @__PURE__ */ (() => ".result{text-align:center}.result .success svg{color:#32c682;text-align:center;margin-top:40px}.result .failure svg{color:#f56c6c;text-align:center;margin-top:40px}.result .title{margin-top:25px}.result .desc{margin-top:25px;width:60%;margin-left:20%;color:#00000073}.result .content{margin-top:20px;width:80%;border-radius:10px;background-color:#fff;margin-left:10%}.result .extra{padding-top:10px;border-top:1px whitesmoke solid;margin-top:25px}\n")();
const _hoisted_1 = { class: "result" };
const _hoisted_2 = {
  key: 0,
  viewBox: "64 64 896 896",
  "data-icon": "close-circle",
  width: "80px",
  height: "80px",
  fill: "currentColor",
  "aria-hidden": "true",
  focusable: "false",
  class: ""
};
const _hoisted_3 = /* @__PURE__ */ createElementVNode("path", { d: "M685.4 354.8c0-4.4-3.6-8-8-8l-66 .3L512 465.6l-99.3-118.4-66.1-.3c-4.4 0-8 3.5-8 8 0 1.9.7 3.7 1.9 5.2l130.1 155L340.5 670a8.32 8.32 0 0 0-1.9 5.2c0 4.4 3.6 8 8 8l66.1-.3L512 564.4l99.3 118.4 66 .3c4.4 0 8-3.5 8-8 0-1.9-.7-3.7-1.9-5.2L553.5 515l130.1-155c1.2-1.4 1.8-3.3 1.8-5.2z" }, null, -1);
const _hoisted_4 = /* @__PURE__ */ createElementVNode("path", { d: "M512 65C264.6 65 64 265.6 64 513s200.6 448 448 448 448-200.6 448-448S759.4 65 512 65zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372 372 166.6 372 372-166.6 372-372 372z" }, null, -1);
const _hoisted_5 = [
  _hoisted_3,
  _hoisted_4
];
const _hoisted_6 = {
  key: 1,
  viewBox: "64 64 896 896",
  "data-icon": "check-circle",
  width: "80px",
  height: "80px",
  fill: "currentColor",
  "aria-hidden": "true",
  focusable: "false",
  class: ""
};
const _hoisted_7 = /* @__PURE__ */ createElementVNode("path", { d: "M699 353h-46.9c-10.2 0-19.9 4.9-25.9 13.3L469 584.3l-71.2-98.8c-6-8.3-15.6-13.3-25.9-13.3H325c-6.5 0-10.3 7.4-6.5 12.7l124.6 172.8a31.8 31.8 0 0 0 51.7 0l210.6-292c3.9-5.3.1-12.7-6.4-12.7z" }, null, -1);
const _hoisted_8 = /* @__PURE__ */ createElementVNode("path", { d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372 372 166.6 372 372-166.6 372-372 372z" }, null, -1);
const _hoisted_9 = [
  _hoisted_7,
  _hoisted_8
];
const _hoisted_10 = { class: "title" };
const _hoisted_11 = { class: "desc" };
const _hoisted_12 = { class: "content" };
const _hoisted_13 = { class: "extra" };
const __default__ = {
  name: "LayResult"
};
const _sfc_main = defineComponent({
  ...__default__,
  props: {
    title: { default: "\u63D0\u4EA4\u4FE1\u606F" },
    status: { default: "success" },
    describe: { default: "\u8BF7\u6838\u5BF9\u5E76\u4FEE\u6539\u4EE5\u4E0B\u4FE1\u606F\u540E\uFF0C\u518D\u91CD\u65B0\u63D0\u4EA4\u3002" }
  },
  setup(__props) {
    useSlots();
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        createElementVNode("div", {
          class: normalizeClass([__props.status])
        }, [
          __props.status === "failure" ? (openBlock(), createElementBlock("svg", _hoisted_2, _hoisted_5)) : (openBlock(), createElementBlock("svg", _hoisted_6, _hoisted_9))
        ], 2),
        createElementVNode("h2", _hoisted_10, toDisplayString(__props.title), 1),
        createElementVNode("p", _hoisted_11, toDisplayString(__props.describe), 1),
        createElementVNode("div", _hoisted_12, [
          renderSlot(_ctx.$slots, "content")
        ]),
        createElementVNode("div", _hoisted_13, [
          renderSlot(_ctx.$slots, "extra")
        ])
      ]);
    };
  }
});
const component = withInstall(_sfc_main);
export { component as default };
